CMS_FINAL(3)

NAME
CMS_final - finalise a CMS_ContentInfo structure

SYNOPSIS
libcrypto
#include <openssl/cms.h>
int
CMS_final(CMS_ContentInfo *cms, BIO *data, BIO *dcont, unsigned int flags);

DESCRIPTION
CMS_final() finalises the structure cms. Its purpose is to perform any operations necessary on cms (digest computation for example) and set the appropriate fields. The parameter data contains the content to be processed. The dcont parameter contains a BIO to write content to after processing: this is only used with detached data and will usually be set to NULL.

This function will normally be called when the CMS_PARTIAL flag is used. It should only be used when streaming is not performed because the streaming I/O functions perform finalisation operations internally.

RETURN VALUES
CMS_final() returns 1 for success or 0 for failure.

SEE ALSO
CMS_ContentInfo_new(3), CMS_encrypt(3), CMS_sign(3), ERR_get_error(3)

HISTORY
CMS_final() first appeared in OpenSSL 0.9.8h and has been available since OpenBSD 6.7.